function [TotTim,TotDis,AvgSpeed,AvgAcc,AvgDeacc,Active,NoFrame,X,Y,Z,x_max,y_max,z_max,V,A,Ang,AngNo,X1pix,Y1pix,Z1pix] = AvgCal(XYZ,SI1,TI1,Tank)
    
    
    T = 1/8 - XYZ(:,1);
    T=T.*0+1/8;
    
    TotTim=sum(T);
    
    Mx1 = Tank.Length;%size(SI1,2);
    My1 = Tank.Height;%size(SI1,1);
%     R1 = size(SI1,2)/size(TI1,2);
    
    x_max=Mx1;
    y_max=Tank.Width;%size(TI1,1)*R1;
    z_max=My1;

%     X = Mx1-XYZ(:,2);
%     Z = My1-XYZ(:,3);
%     Y = XYZ(:,5)*R1;
    X = XYZ(:,2);
    Z = z_max-XYZ(:,3);
    Y = XYZ(:,5);
    
    X1pix=X*(size(SI1,2)/Tank.Length);
    Y1pix=Y*(size(TI1,1)/Tank.Width);
    Z1pix=(size(SI1,1))-Z*(size(SI1,1)/Tank.Height);
    
    
    D = sqrt((X(1:end-1)-X(2:end)).^2+(Y(1:end-1)-Y(2:end)).^2+(Z(1:end-1)-Z(2:end)).^2);
    V = D./(T(2:end));
    A = (V(1:end-1)-V(2:end))./(T(1:end-2)+T(2:end-1));
    
    X1=X(1:end-2);
    X2=X(2:end-1);
    X3=X(3:end);
    Y1=Y(1:end-2);
    Y2=Y(2:end-1);
    Y3=Y(3:end);
    Z1=Z(1:end-2);
    Z2=Z(2:end-1);
    Z3=Z(3:end);
        
    a=[X(1:end-2)-X(2:end-1),Y(1:end-2)-Y(2:end-1),Z(1:end-2)-Z(2:end-1)];
    b=[X(2:end-1)-X(3:end-0),Y(2:end-1)-Y(3:end-0),Z(2:end-1)-Z(3:end-0)];    
    th=acosd((sum(a'.*b'))./(sqrt(sum(a'.^2)).*sqrt(sum(b'.^2))));
    th(isnan(th))=0;
    th(end+1:end+2)=th(end);
    Ang =th';

    V(end+1)=V(end);
    A(end+1:end+2)=A(end);
%     AB=sqrt((X1-X2).^2+(Y1-Y2).^2+(Z1-Z2).^2);
%     BC=sqrt((X2-X3).^2+(Y2-Y3).^2+(Z2-Z3).^2);
%     AC=sqrt((X3-X1).^2+(Y3-Y1).^2+(Z3-Z1).^2);
%     
%     
%     Ang=acosd((BC.^2+AB.^2-AC.^2)./(2.*BC.*AB));
     AngNo=100*sum(Ang>90)/length(Ang);
    
    
    TotDis=sum(D);
    AvgSpeed=mean(V);
    AvgAcc=mean(A(A>0));
    AvgDeacc=-1*mean(A(A<0));
    Active=100*sum(D>0.01)./length(D);
    NoFrame=length(A);